"""
/***************************************************************************
 LumigisDialogXdep88
                                 A QGIS plugin
 Gestion du patrimoine éclairage public - extraction kit entreprise
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                             -------------------
        begin                : 2021-10-04
        git sha              : $Format:%H$
        copyright            : (C) 2021 by Jean-Marie Arsac
        email                : jmarsac@azimut.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os

from qgis.PyQt import QtWidgets, uic

# This loads your .ui file so that PyQt can populate your plugin with the elements from Qt Designer
FORM_CLASS, _ = uic.loadUiType(
    os.path.join(os.path.dirname(__file__), "lumigis_dialog_xdep88.ui")
)


class LumigisDialogXdep88(QtWidgets.QDialog, FORM_CLASS):
    """Class LumigisDialogXdep88 implementation"""

    def __init__(self, dbutil, parent=None):
        """Constructor."""
        super(LumigisDialogXdep88, self).__init__(parent)
        # Set up the user interface from Designer through FORM_CLASS.
        # After self.setupUi() you can access any designer object by doing
        # self.<objectname>, and you can use autoconnect slots - see
        # http://doc.qt.io/qt-5/designer-using-a-ui-file.html
        # #widgets-and-dialogs-with-auto-connect
        self.db_util = dbutil
        self._bdversion = "1.0"
        self._insee = None
        self._city = None
        self._kit = None
        self._lot = None
        self._technician = None
        self._intervention = None
        self._intervention_id = None
        self._description = None
        self._entreprise = None
        self._sinfoni = None
        self._year = None
        self._market = None

        self.setupUi(self)

    @property
    def intervention(self):
        return self._intervention

    @intervention.setter
    def intervention(self, inter):
        self._intervention = inter

    @property
    def intervention_id(self):
        return self._intervention_id

    @intervention_id.setter
    def intervention_id(self, inter_id):
        self._intervention_id = inter_id

    @property
    def kit(self):
        return self._kit

    @kit.setter
    def kit(self, kit_name):
        self._kit = kit_name

    @property
    def bdversion(self):
        return self._bdversion

    @property
    def year(self):
        return self._year

    @property
    def city(self):
        return self._city

    @property
    def lot(self):
        return self._lot

    @property
    def technician(self):
        return self._technician

    @property
    def description(self):
        return self._description

    @property
    def entreprise(self):
        return self._entreprise

    @property
    def sinfoni(self):
        return self._sinfoni

    @property
    def market(self):
        return self._market

    def keyPressEvent(self, event):
        if not self.lineEdit_lot.hasSelectedText():
            pretext = self.lineEdit_lot.text()
            self.lineEdit_lot.setText(pretext.__str__().upper())
        # return QtGui.QLineEdit.keyPressEvent(self, event)

    def check_values_enable_ok_button(self, query):
        if (
            self.comboBox_market.currentText()
            and self.comboBox_technician.currentText()
            and self.comboBox_city.currentText()
            and self.lineEdit_year.text()
            and self.lineEdit_lot.text()
            and self.lineEdit_sinfoni.text()
        ):
            self.pushButton_create_kit.setEnabled(True)
            sql_string = (
                "select id from t_r_insee_communes "
                f"where libelle = '{self.comboBox_city.currentText()}'"
            )
            insee = None
            if query.exec(sql_string):
                if query.first():
                    insee = query.value(0)
            if insee:
                self._city = self.comboBox_city.currentText()
                self._lot = self.lineEdit_lot.text()
                self._year = self.lineEdit_year.text()
                self._sinfoni = f"{self.lineEdit_sinfoni.text()}"
                self._intervention = self._year + self._lot + self._sinfoni
                self._kit = (
                    f"{self._year}-" f"{self._lot}-" f"{self._sinfoni}-" f"{insee}"
                )
                self._market = self.comboBox_market.currentText()

    def check_intervention_update_description(self, query):
        self._intervention = None
        self.label_result.setText("")

        """
        if self.lineEdit_year.text():
            if self.lineEdit_year.text() == "0000":
                DlgUtil.load_combobox_list(
                    self.comboBox_city,
                    self.db_util.query,
                    "SELECT libelle FROM sig_ref.t_r_insee_communes ORDER BY code",
                )
        """
        if (
            self.lineEdit_year.text()
            and self.lineEdit_lot.text()
            and self.lineEdit_sinfoni.text()
        ):
            idnom = (
                self.lineEdit_year.text()
                + self.lineEdit_lot.text()
                + f"{self.lineEdit_sinfoni.text()}"
            )
            sql_string = (
                "select description, entreprise, id from vue_interventions "
                f"where idnom = '{idnom}'"
            )
            if query.exec(sql_string):
                if query.first():
                    self.label_description.setText(query.value(0))
                    self.label_entreprise.setText(query.value(1))
                    self._technician = self.comboBox_technician.currentText()
                    self._intervention = idnom
                    self._description = query.value(0)
                    self._entreprise = query.value(1)
                    self._intervention_id = query.value(2)
            self.check_values_enable_ok_button(query)
